;==================================================
; ADC output s122 Hz
; ݔ32PSINC4ƽ  s3.8hzݔ
; e bit 0 ~ bit 43
; ΢ bit 20 ~ bit 43
; IZALIZAMIZAHIZAUIZAY IZAX  =  e֕1
; IZBLIZBMIZBHIZBUIBAY IBAX  =  e֕2
; IZCLIZCMIZCHIZCUICAY ICAX  =  e֕3
; IZDLIZDMIZDHIZDUIDAY IDAX  =  e֕4
; DZALDZAMDZAH ' ΢֕1
; DZBLDZBMDZBH ' ΢֕2
; DZCLDZCMDZCH ' ΢֕3
; DZDLDZDMDZDH ' ΢֕4
;==================================================
; function: ADCDQAV
; input: ADC0RH/M/L
; output: BADNEWH/M/L 
;=================================================
IntADC:
	btss  Flag,b_ADC,acce		;ДADCǷѽDQһP
	ret	  			      ;]DQɄt˳
	bcf   Flag,b_ADC,acce		;DQɄtIcMV̎
	btsz  flag,b_cal,acce         ;жǷڽУ      
	jmp   INTSINC4
	mvl   00h
	cpse  Sgncnt,acce
	jmp   IntADC1
	btsz  flag,b_ADCAth,acce
	jmp   INTSINC4
	bsf   flag,b_ADCath,acce
	mvl   02h
	mvf   ADcquit,f,acce
	ret
IntADC1:
      mvl   01h
      cpse  Sgncnt,acce
      jmp   IntADC2
      btsz  flag,b_ADCath,acce
      jmp   control_Space
      bsf   flag,b_ADCAth,acce
      mvl   04h
      mvf   count,f,acce
      mvl   02h
	mvf   ADcquit,f,acce
      ret
IntADC2:
      mvl   02h
      cpse  Sgncnt,acce
      ret
      btsz  flag,b_ADCath,acce
      jmp   control_Zero     
      bsf   flag,b_ADCath,acce
      mvl   04h
      mvf   count,f,acce
      mvl   02h
	mvf   ADcquit,f,acce
      ret 	
;=================================================	
INTSINC4:
    mvf     ADCRL,W,ACCE      ;e1 + ADC --> e1 
    addf    IZAL,F,b
    mvf     ADCRM,W,acce
    addc    IZAM,F,b
    mvf     ADCRH,W,ACCE
    addc    IZAH,F,b
    mvl     0
    btsz    ADCRH,7,ACCE
    mvl     0FFh
    addc    IZAU,F,b
    addc    IZAY,F,b
    addc    IZAX,F,b
            
    mvf     IZAL,W,b       ;e1 + e2 --> e2
    addf    IZBL,F,b
    mvf     IZAM,W,b
    addc    IZBM,F,b
    mvf     IZAH,W,b
    addc    IZBH,F,b
    mvf     IZAU,W,b
    addc    IZBU,F,b
    mvf     IZAY,W,b
    addc    IZBY,F,b
    mvf     IZAX,W,b
    addc    IZBX,F,b
            
    mvf     IZBL,W,b       ;e2 + e3 --> e3
    addf    IZCL,F,b
    mvf     IZBM,W,b
    addc    IZCM,F,b
    mvf     IZBH,W,b
    addc    IZCH,F,b
    mvf     IZBU,W,b
    addc    IZCU,F,b
    mvf     IZBY,W,b
    addc    IZCY,F,b
    mvf     IZBX,W,b
    addc    IZCX,F,b
            
    mvf     IZCL,W,b      ;e3 + e4 --> e4
    addf    IZDL,F,b
    mvf     IZCM,W,b
    addc    IZDM,F,b
    mvf     IZCH,W,b
    addc    IZDH,F,b
    mvf     IZCU,W,b
    addc    IZDU,F,b
    mvf     IZCY,W,b
    addc    IZDY,F,b
    mvf     IZCX,W,b
    addc    IZDX,F,b
            
    inf	ADCCnter,W,acce
    mvl	31                 ; ۼ32
    cpsl	ADCCnter,acce
    jmp    INTER_DVIN4
    inf    ADCCnter,F,acce
    jmp    Inter_4_out
;================================	
INTER_DVIN4:
    mvl     0C0h	
    andf    ADCCnter,F,acce
    inf     WECNT,F,acce
INTER_DVOU4:	
    mvff    IZDL,BIOUL       ;e4  --> Buffer
    mvff    IZDM,BIOUM	
    mvff    IZDH,BIOUH	
    mvff    IZDU,BIOUU	
    mvff    IZDY,BIOUY	
    mvff    IZDX,BIOUX	
    mvl     4                  ;ȡBufferBit 20 ~ 44
LINTER_DVOULOOP4:	
    bcf      Status,C,ACCE
    rrfc     BIOUX,F,b
    rrfc     BIOUY,F,b
    rrfc     BIOUU,F,b
    rrfc     BIOUH,F,b
    rrfc     BIOUM,F,b
    rrfc     BIOUL,F,b
    dcsz     WREG,F,ACCE
    jmp      LINTER_DVOULOOP4
    	     
    mvf      DZAL,W,b        ;Buffer - ΢1 --> BufferA
    subf     BIOUH,W,b
    mvf      BADCOL,F,b
    mvf      DZAM,W,b
    subc     BIOUU,W,b
    mvf      BADCOM,F,b
    mvf      DZAH,W,b
    subc     BIOUY,W,b
    mvf      BADCOH,F,b
    mvff     BIOUH,DZAL          ; Buffer --> ΢1
    mvff     BIOUU,DZAM
    mvff     BIOUY,DZAH
             
    mvf      DZBL,W,b        ; BufferA - ΢2 --> BufferB
    subf     BADCOL,W,b
    mvf      BBBADNEWL,F,b
    mvf      DZBM,W,b
    subc     BADCOM,W,b	
    mvf      BBBADNEWM,F,b
    mvf      DZBH,W,b
    subc     BADCOH,W,b	
    mvf      BBBADNEWH,F,b	
    mvff     BADCOL,DZBL        ; BufferA --> ΢2
    mvff     BADCOM,DZBM
    mvff     BADCOH,DZBH
             
    mvf      DZCL,W,b        ; BufferB - ΢2 --> BufferA
    subf     BBBADNEWL,W,b
    mvf      BADCOL,F,b	
    mvf      DZCM,W,b
    subc     BBBADNEWM,W,b
    mvf      BADCOM,F,b	
    mvf      DZCH,W,b
    subc     BBBADNEWH,W,b
    mvf      BADCOH,F,b	
    mvff     BBBADNEWL,DZCL      ; BufferB --> ΢3
    mvff     BBBADNEWM,DZCM
    mvff     BBBADNEWH,DZCH
             
             
    mvf      DZDL,W,b       ; BufferA - ΢4 --> BufferB
    subf     BADCOL,W,b
    mvf      BBBADNEWL,F,b	
    mvf      DZDM,W,b
    subc     BADCOM,W,b	
    mvf      BBBADNEWM,F,b
    mvf      DZDH,W,b
    subc     BADCOH,W,b	
    mvf      BBBADNEWH,F,b
    mvff     BADCOL,DZDL         ; BufferA --> ΢4
    mvff     BADCOM,DZDM
    mvff     BADCOH,DZDH
             
    mvff     BBBADNEWH,BADNEWH      ;BufferAݔADC Output
    mvff     BBBADNEWM,BADNEWM
    mvff     BBBADNEWL,BADNEWL
    call    getADC
    mvff    temp,ADCOUTL
    mvff    temp+1,ADCOUTM
    mvff    temp+2,ADCOUTH
    btsz    flag,b_cal,acce
    jmp     IntADC_exit
    mvl     10000010b			;X1
    mvf     ADCCN1,f,acce 
    mvl     10000000b		     
    mvf     ADCCN3,F,ACCE   
    mvl     10101000b               ;лAI5-ACM              
    mvf     AINET1,f,acce
    bcf     flag,b_ADCath,acce
    inf     sgncnt,f,acce
;=======================================
Inter_4_out:
      ret
;================ۼı===================
control_zero:
control_SPace:
	mvl	40h
	addf	ADnewH,f,acce
      mvf   ADnewL,w,acce
      addf  buffer,f,acce
      mvf   ADnewM,w,acce
      addc  buffer+1,f,acce
      mvf   ADnewH,w,acce
      addc  buffer+2,f,acce 
      mvl   00h
      addc  buffer+3,f,acce
      dcsz  count,f,acce
      ret 
;===========buffer/4======================= 
      bcf   status,c,acce
      rrfc  buffer+3,f,acce
      rrfc  buffer+2,f,acce
      rrfc  buffer+1,f,acce
      rrfc  buffer,f,acce
      bcf   status,c,acce
      rrfc  buffer+3,f,acce
      rrfc  buffer+2,f,acce
      rrfc  buffer+1,f,acce
      rrfc  buffer,f,acce  
      mvl	40h
      subf	buffer+2,f,acce
;=======õݸ BADNEWL/M/H==========           
      mvff  buffer,BADNEWL
      mvff  buffer+1,BADNEWM 
      mvff  buffer+2,BADNEWH  
      clrf  buffer,acce
      clrf  buffer+1,acce
      clrf  buffer+2,acce  
      clrf  buffer+3,acce 
      mvl   01h
      cpse  sgncnt,acce
      jmp   change_chopper
      call  getADC            ;ȡЧλ    
      mvff  temp,ZeroL
      mvff  temp+1,ZeroM
      mvff  temp+2,ZeroH
      mvl   10100100b               ;лAI7-ACM
      mvf   AINET1,f,acce
      bcf   flag,b_ADCath,acce
      inf   sgncnt,f,acce
      ret      
;==============================================      
change_chopper:
      call  getADC            ;ȡЧλ
      mvff  temp,SpaceL
      mvff  temp+1,SpaceM
      mvff  temp+2,SpaceH
      mvl   01000000b		;128Hz output
	mvf   ADCCN3,F,ACCE
      mvl   10000101b
      mvf   ADCCN1,f,acce
      mvl   01101100b               ;лAI2-A3
      mvf   AINET1,f,acce
      bcf   flag,b_ADCath,acce
      clrf  sgncnt,acce
;================================      
IntADC_exit:      
      bsf   flag,b_ADOK,acce
      btss  flag,b_cal,acce
      ret
      mvff  ADCOUTL,dispdata1
      mvff  ADCOUTM,dispdata2
      mvl   04h
IntADC_exit1:
      bcf   status,c,acce
      rrfc  dispdata2,f,acce
      rrfc  dispdata1,f,acce
      dcsz  wreg,f,acce
      jmp   IntADC_exit1      
      ret                   
;============================================               
;function:ԓADCVĔMȡЧλ̎
;input: BADNEWH/M/L
;output: ADCOUTH/M/L
;==================================================
GetADC:
      bcf	  status,c,acce
   	btsz	  BADNEWH,7,b
	bsf	  status,c,acce		;ȥһλ̖λ


	rlfc    BADNEWL,F,b
	rlfc    BADNEWM,F,b
	rlfc    BADNEWH,F,b
	
	mvff	  BADNEWH,temp+2			 ;ADC^ܛVĔ浽ADCOUTH/M/L
	mvff	  BADNEWM,temp+1
	mvff	  BADNEWL,temp
      mvl	  07h 
     ; tfsz    sgncnt,acce
     ; mvl     09h    
GETADC_AVENDLOOP:   				;ȡADCЧλλ24-ADshiftbit
	bcf	  status,c,acce
	btsz    BADNEWH,7,b			;ԓλؓt1tλ0	
	bsf	  status,c,acce
	rrfc    temp+2,F,ACCE
	rrfc    temp+1,F,ACCE
	rrfc    temp,F,ACCE
	dcsz    wreg,F,ACCE
	jmp     GETADC_AVENDLOOP 
GETADC_ADCEND: 
      ret 
;========================================= 